import sys
import weakref
import gtk


class Father(object):

    def __init__(self):
        self.children = []
        self.objects = []
        self.w = gtk.Window()
        self.h = gtk.HBox()
        self.kill_button = gtk.Button("kill")
        self.crea_button = gtk.Button("crea %s finestre" % n)
        self.w.add(self.h)
        self.h.add(self.crea_button)
        self.h.add(self.kill_button)
        self.w.show_all()
        self.w.connect('destroy', gtk.main_quit)
        self.kill_button.connect('clicked', self.clicked_cb)
        self.crea_button.connect('clicked', self.crea_molte_finestre)

    def crea_molte_finestre(self, win, ev=None):
        for i in range(n):
            obj = Child(title=str(i))
            r = weakref.ref(obj)
            self.children.append(r)
            self.objects.append(obj)

    def clicked_cb(self, win):
        for g in self.children:
            obj = g()
            print obj
            if obj is not None:
                obj.destroy()
        del self.children[:]
        del self.objects[:]


class Child(object):

    def __init__(self, title):
        self.title = title
        self.w = gtk.Window()
        self.w.set_title(title)
        self.h = gtk.HBox()
        self.kill_button = gtk.Button("kill")
        self.crea_button = gtk.Button("Finestra %s" % title)
        self.w.add(self.h)
        self.h.add(self.crea_button)
        self.h.add(self.kill_button)
        self.w.show_all()
        self.kill_button.connect('clicked', self.destroy)

    def destroy(self, win=None):
        self.w.destroy()


if __name__ == '__main__' :
    if len(sys.argv) == 2:
        n = int(sys.argv[1])
    else:
        n = 10
    obj = Father()
    obj.w.connect('destroy', gtk.main_quit)
    try:
        gtk.main()
    except KeyboardInterrupt:
        sys.exit()
